# CbcSOSBranchingObject Class Reference

Branching object for Special ordered sets. More...

`#include <CbcSOS.hpp>`

Inheritance diagram for CbcSOSBranchingObject:
[legend]
Collaboration diagram for CbcSOSBranchingObject:
[legend]

List of all members.

## Public Member Functions
| CbcSOSBranchingObject ()
| CbcSOSBranchingObject (CbcModel *model, const CbcSOS *clique, int way, double separator)
| CbcSOSBranchingObject (const CbcSOSBranchingObject &)
CbcSOSBranchingObject & | operator= (const CbcSOSBranchingObject &rhs)
| Assignment operator.
virtual CbcBranchingObject * | clone () const
| Clone.
virtual | ~CbcSOSBranchingObject ()
virtual double | branch ()
| Does next branch and updates state.
virtual void | fix (OsiSolverInterface *solver, double *lower, double *upper, int branchState) const
| Update bounds in solver as in 'branch' and update given bounds.
virtual void | previousBranch ()
| Reset every information so that the branching object appears to point to the previous child.
virtual void | print ()
| Print something about branch - only if log level high.
virtual CbcBranchObjType | type () const
| Return the type (an integer identifier) of `this`.
virtual int | compareOriginalObject (const CbcBranchingObject *brObj) const
| Compare the original object of `this` with the original object of `brObj`.
virtual CbcRangeCompare | compareBranchingObject (const CbcBranchingObject *brObj, const bool replaceIfOverlap=false)
| Compare the `this` with `brObj`.
void | computeNonzeroRange ()
| Fill out the `firstNonzero_` and `lastNonzero_` data members.
## Private Attributes
const CbcSOS * | set_
| data
double | separator_
| separator
int | firstNonzero_
| The following two members describe the range in the members_ of the original object that whose upper bound is not fixed to 0.
int | lastNonzero_

## Detailed Description

Branching object for Special ordered sets.

Variable_ is the set id number (redundant, as the object also holds a pointer to the set.

Definition at line 189 of file CbcSOS.hpp.

## Constructor & Destructor Documentation

CbcSOSBranchingObject::CbcSOSBranchingObject | ( |  | ) |

CbcSOSBranchingObject::CbcSOSBranchingObject | ( | CbcModel * | model,
|  | const CbcSOS * | clique,
|  | int | way,
|  | double | separator |
| ) |  |  |

CbcSOSBranchingObject::CbcSOSBranchingObject | ( | const CbcSOSBranchingObject & |  | ) |

virtual CbcSOSBranchingObject::~CbcSOSBranchingObject | ( |  | ) | `[virtual]`

## Member Function Documentation

CbcSOSBranchingObject& CbcSOSBranchingObject::operator= | ( | const CbcSOSBranchingObject & | rhs | ) |

Assignment operator.

Reimplemented from CbcBranchingObject.

virtual CbcBranchingObject* CbcSOSBranchingObject::clone | ( |  | ) | const`[virtual]`

Clone.

Implements CbcBranchingObject.

virtual double CbcSOSBranchingObject::branch | ( |  | ) | `[virtual]`

Does next branch and updates state.

Implements CbcBranchingObject.

virtual void CbcSOSBranchingObject::fix | ( | OsiSolverInterface * | solver,
|  | double * | lower,
|  | double * | upper,
|  | int | branchState |
| ) |  |  | const`[virtual]`

Update bounds in solver as in 'branch' and update given bounds.

branchState is -1 for 'down' +1 for 'up'

Reimplemented from CbcBranchingObject.

virtual void CbcSOSBranchingObject::previousBranch | ( |  | ) | `[inline, virtual]`

Reset every information so that the branching object appears to point to the previous child.

This method does not need to modify anything in any solver.

Reimplemented from CbcBranchingObject.

Definition at line 225 of file CbcSOS.hpp.

virtual void CbcSOSBranchingObject::print | ( |  | ) | `[virtual]`

Print something about branch - only if log level high.

virtual CbcBranchObjType CbcSOSBranchingObject::type | ( |  | ) | const`[inline, virtual]`

Return the type (an integer identifier) of `this`.

Implements CbcBranchingObject.

Definition at line 236 of file CbcSOS.hpp.

virtual int CbcSOSBranchingObject::compareOriginalObject | ( | const CbcBranchingObject * | brObj | ) | const`[virtual]`

Compare the original object of `this` with the original object of `brObj`.

Assumes that there is an ordering of the original objects. This method should be invoked only if `this` and brObj are of the same type. Return negative/0/positive depending on whether `this` is smaller/same/larger than the argument.

virtual CbcRangeCompare CbcSOSBranchingObject::compareBranchingObject | ( | const CbcBranchingObject * | brObj,
|  | const bool | replaceIfOverlap = `false` |
| ) |  |  | `[virtual]`

Compare the `this` with `brObj`.

`this` and `brObj` must be os the same type and must have the same original object, but they may have different feasible regions. Return the appropriate CbcRangeCompare value (first argument being the sub/superset if that's the case). In case of overlap (and if `replaceIfOverlap` is true) replace the current branching object with one whose feasible region is the overlap.

void CbcSOSBranchingObject::computeNonzeroRange | ( |  | ) |

Fill out the `firstNonzero_` and `lastNonzero_` data members.

## Member Data Documentation

const CbcSOS* CbcSOSBranchingObject::set_`[private]`

data

Definition at line 265 of file CbcSOS.hpp.

double CbcSOSBranchingObject::separator_`[private]`

separator

Definition at line 267 of file CbcSOS.hpp.

int CbcSOSBranchingObject::firstNonzero_`[private]`

The following two members describe the range in the members_ of the original object that whose upper bound is not fixed to 0.

This is not necessary for Cbc to function correctly, this is there for heuristics so that separate branching decisions on the same object can be pooled into one branching object.

Definition at line 273 of file CbcSOS.hpp.

int CbcSOSBranchingObject::lastNonzero_`[private]`

Definition at line 274 of file CbcSOS.hpp.

The documentation for this class was generated from the following file:

- /home/coin/svn-release/Cbc-2.7.8/Cbc/src/CbcSOS.hpp

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Defines